<template>
	<div id="app">
		<Navbar/>
		<transition name="fade" mode="out-in">
			<router-view/>
		</transition>
	</div>
</template>


<script>
import Navbar from '@/components/Navbar';

export default {
	components: {Navbar,},
	computed: {
		authToken() {
			return this.$store.state.persistent.authToken;
		},
	},
	watch: {
		authToken() {
			console.debug('Auth token changed, calling getMe...');
			this.$http.defaults.headers['Authorization'] = `Token ${this.authToken}`;
			this.checkTokenGetMe();
		},
	},
	methods: {
		checkTokenGetMe() {
			this.$http.get('/me/')
				.then(r => {
					const data = r.data;
					this.$store.commit('persistent/setMe', {
						...data.data,
						userRepr: data.user_repr,
					});
				})
				.catch(e => {
					console.info('Failed to retrieve /me/', e);
					if (e.response.status === 403 || e.response.status === 401) {
						this.$store.commit('persistent/deleteCreds');
						this.$http.defaults.headers['Authorization'] = undefined;
						this.$router.replace('/').catch(() => {
						});
					}
				});
		},
	},
	mounted() {
		this.checkTokenGetMe();
	},
};
</script>

<style>
body {
	font-family: 'Open Sans', -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto,
	'Helvetica Neue', Arial, 'Noto Sans', sans-serif,
	'Apple Color Emoji', 'Segoe UI Emoji', 'Segoe UI Symbol', 'Noto Color Emoji' !important;

	font-size: .875rem;
	overflow-y: auto;
	overflow-x: hidden;
	margin: 0;
	padding: 0;
}

code {
	font-family: 'JetBrains Mono', 'Ubuntu Mono', 'Lucida Console',
	monospace, monospace !important;
}

/*noinspection CssUnusedSymbol*/
.fade-enter-active, .fade-leave-active {
	transition: opacity .3s;
}

/*noinspection CssUnusedSymbol*/
.fade-enter, .fade-leave-to {
	opacity: 0;
}

/*noinspection CssUnusedSymbol*/
.full-height {
	height: calc(100vh - 56px)
}

/* Colors from tg */
/*noinspection CssUnusedSymbol*/
.bg-main {
	background-color: #5349a0 !important;
}

/*noinspection CssUnusedSymbol*/
.btn-outline-custom {
	color: #6cebfc !important;
	border-color: #6cebfc !important;
}

/*noinspection CssUnusedSymbol*/
.btn-outline-custom:hover {
	color: #ffffff !important;
	background-color: #6cebfc !important;
	border-color: #6cebfc !important;
}

/*noinspection CssUnusedSymbol*/
.btn-outline-custom-dark {
	color: #5349a0 !important;
	border-color: #5349a0 !important;
}

/*noinspection CssUnusedSymbol*/
.btn-outline-custom-dark:hover {
	color: #ffffff !important;
	background-color: #5349a0 !important;
	border-color: #5349a0 !important;
}
</style>
